unit Vraag2U_Memo;

// Oplossing vir Vraag 2.2

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls, StudentU;

type
  TfrmVraagTwee = class(TForm)
    bmbSluitAf: TBitBtn;
    lblFormOpskrif: TLabel;
    redVraag2: TRichEdit;
    pnlKnoppies: TPanel;
    btnVraag222: TButton;
    btnVraag221: TButton;
    pnlVraag223: TPanel;
    btnVraag223: TButton;
    lblTotaal: TLabel;
    edtTotaleSessies: TEdit;
    btnVraag224: TButton;
    pnlVordering: TPanel;
    lblVordering: TLabel;
    lblIsVoltooi: TLabel;
    chkIsVoltooi: TCheckBox;
    lblOpleidingsdatum: TLabel;
    edtOpleiDatum: TEdit;
    lblStudent: TLabel;
    lblRegDatum: TLabel;
    lblRegKode: TLabel;
    edtNaam: TEdit;
    edtRegKode: TEdit;
    edtRegDatum: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnVraag221Click(Sender: TObject);
    procedure btnVraag222Click(Sender: TObject);
    procedure btnVraag223Click(Sender: TObject);
    procedure btnVraag224Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraagTwee: TfrmVraagTwee;

implementation

var
  objStudent: TStudent;
{$R *.dfm}
{$R+}

  // ==================================================================
  // Vraag 2.2.1
procedure TfrmVraagTwee.btnVraag221Click(Sender: TObject);

begin
  objStudent := TStudent.Create(edtNaam.text, edtRegKode.text, edtRegDatum.text);

  redVraag2.Lines.Clear;
  redVraag2.Lines.Add(objStudent.toString);
end;

// ==================================================================
// Vraag 2.2.2
procedure TfrmVraagTwee.btnVraag222Click(Sender: TObject);
var
  TxtLeer: Textfile;
  sReel, sRegKode, sDatum: string;
  iTel: integer;
begin

  if not FileExists('DataV2.txt') then
  begin
    MessageDlg('Leer bestaan nie.', mtError, [mbOk], 0);
    Exit;
  end;

  AssignFile(TxtLeer, 'DataV2.txt');
  Reset(TxtLeer);

  iTel := 0;
  redVraag2.Clear;
  redVraag2.Lines.Add('Naam van student: ' + objStudent.GetNaam);
  redVraag2.Lines.Add('Datums van voltooide sessies:');
  while NOT EOF(TxtLeer) do
  begin
    readln(TxtLeer, sReel);
    if pos(objStudent.GetKode, sReel) = 1 then
    begin
      Delete(sReel, 1, pos('op ', sReel) + 2);
      sDatum := copy(sReel, 1, pos('#', sReel) - 1);
      Delete(sReel, 1, pos('#', sReel));
      if sReel = 'Voltooi' then
      begin
        redVraag2.Lines.Add(sDatum);
        inc(iTel, 1);
      end;
    end;
  end; // while
  objStudent.setSessiesVoltooi(iTel);
  CloseFile(TxtLeer);

  redVraag2.Lines.Add(#10);
  redVraag2.Lines.Add(objStudent.toString);

  btnVraag223.Enabled := true;
  btnVraag224.Enabled := true;
end;

// ==================================================================
// Vraag 2.2.3
procedure TfrmVraagTwee.btnVraag223Click(Sender: TObject);
var
  TxtLeer: Textfile;
  sReel, sVoltooi, sSesDatum: string;
begin
  sSesDatum := edtOpleiDatum.text;

  if chkIsVoltooi.Checked = false then
    sVoltooi := 'Nie voltooi nie'
  else
  begin
    sVoltooi := 'Voltooi';
    objStudent.vermeerderSessiesVoltooi;
  end;

  sReel := objStudent.GetKode + ' het geoefen op ' + sSesDatum + '#' + sVoltooi;

  AssignFile(TxtLeer, 'DataV2.txt');
  Append(TxtLeer);
  writeln(TxtLeer, sReel);
  CloseFile(TxtLeer);

  ShowMessage('Inligting is na die leer geskryf');

  redVraag2.Lines.Clear;
  redVraag2.Lines.Add(objStudent.toString);
end;
// ==================================================================
// Vraag 2.2.4

procedure TfrmVraagTwee.btnVraag224Click(Sender: TObject);
var
  iSessies: integer;
  sVordering: string;
begin
  iSessies := StrToInt(edtTotaleSessies.text);
  sVordering := objStudent.evalueerVordering(iSessies);
  lblVordering.Caption := sVordering;
end;

// ==================================================================
// Supplied code
procedure TfrmVraagTwee.FormCreate(Sender: TObject);
begin
  btnVraag223.Enabled := false;
  btnVraag224.Enabled := false;
end;


// ==================================================================

end.
